//+------------------------------------------------------------------+
//|                                               TP_channels_v1.mq4 |
//|                                                   SyDef Research |
//+------------------------------------------------------------------+
#property copyright "SyDef Research"

#property indicator_chart_window
#property indicator_buffers 8

#property indicator_color1 Teal 
#property indicator_color2 Teal 
#property indicator_color3 Teal 
#property indicator_color4 Teal
#property indicator_color5 Teal
#property indicator_color6 Teal
#property indicator_color7 Teal
#property indicator_color8 Teal


#property indicator_width1 0
#property indicator_width2 0
#property indicator_width3 0  
#property indicator_width4 0
#property indicator_width5 0
#property indicator_width6 0 
#property indicator_width7 0
#property indicator_width8 0 


//---- input parameters

extern int SMA_period = 45;
extern int initial_channel = 178;
extern bool proximity = true;
extern int  proximity_range = 30;


//---- buffers

double up1[];
double up2[];
double up3[];
double up4[];


double down1[];
double down2[];
double down3[];
double down4[];

double my_Point;

int init() {

   IndicatorBuffers(8);
   
//---- drawing settings

   SetIndexStyle( 0, DRAW_LINE, STYLE_DOT );
   SetIndexStyle( 1, DRAW_LINE, STYLE_DOT );
   SetIndexStyle( 2, DRAW_LINE, STYLE_DOT );
   SetIndexStyle( 3, DRAW_LINE, STYLE_DOT );
   SetIndexStyle( 4, DRAW_LINE, STYLE_DOT );
   SetIndexStyle( 5, DRAW_LINE, STYLE_DOT );
   SetIndexStyle( 6, DRAW_LINE, STYLE_DOT );
   SetIndexStyle( 7, DRAW_LINE, STYLE_DOT );

   
   SetIndexBuffer( 0, up1 );
   SetIndexBuffer( 1, down1 );
   SetIndexBuffer( 2, up2 ); 
   SetIndexBuffer( 3, down2 );
   SetIndexBuffer( 4, up3 );
   SetIndexBuffer( 5, down3 );
   SetIndexBuffer( 6, up4 );
   SetIndexBuffer( 7, down4 );
   
   SetIndexEmptyValue( 0, 0 );
   SetIndexEmptyValue( 1, 0 );
   SetIndexEmptyValue( 2, 0 );
   SetIndexEmptyValue( 3, 0 );
   SetIndexEmptyValue( 4, 0 );
   SetIndexEmptyValue( 5, 0 );
   SetIndexEmptyValue( 6, 0 );
   SetIndexEmptyValue( 7, 0 );

   
   switch ( Digits ) {
      
      case 3: my_Point = Point * 10;
      case 4: my_Point = Point;
      case 5: my_Point = Point * 10;
   }
   

//---- name for DataWindow and indicator subwindow label

   IndicatorShortName ("TP_channels");
   
   SetIndexLabel ( 0, "up1" );
   SetIndexLabel ( 1, "down1" );
   SetIndexLabel ( 2, "up2" );
   SetIndexLabel ( 3, "down2" );
   SetIndexLabel ( 4, "up3" );
   SetIndexLabel ( 5, "down3" );
   SetIndexLabel ( 6, "up4" );
   SetIndexLabel ( 7, "down4" );

   
  return;
}


int start() {

//---- get already counted bars    
   int counted_bars = IndicatorCounted();
//---- check for possible errors
   if (counted_bars < 0) return (-1);
   int limit = Bars - counted_bars ;
   
//---- main cycle

   for ( int shift = limit; shift >= 0; shift-- ) {
      
      double sma = iMA( NULL, 0, SMA_period, 0, MODE_SMA, PRICE_CLOSE, shift );
      
      up1[shift] = sma + ( initial_channel / 2 ) * my_Point;
      down1[shift] = sma - ( initial_channel / 2 ) * my_Point;
      
      up2[shift] = up1[shift] + ( initial_channel * 0.32 ) * my_Point;
      down2[shift] = down1[shift] - ( initial_channel * 0.32 ) * my_Point;
      
      up3[shift] = up1[shift] + ( initial_channel * 0.8 ) * my_Point;
      down3[shift] = down1[shift] - ( initial_channel * 0.8 ) * my_Point;
      
      up4[shift] = up1[shift] + ( initial_channel * 1.62 ) * my_Point;
      down4[shift] = down1[shift] - ( initial_channel * 1.62 ) * my_Point;
      
      // Proximity filter
      
      if ( proximity == true ) {
         
         if ( ( ( up1[shift] - High[shift] ) > ( proximity_range * my_Point ) ) || ( ( Low[shift] - up1[shift] ) > ( proximity_range * my_Point ) ) ) up1[shift] = 0;
         if ( ( ( up2[shift] - High[shift] ) > ( proximity_range * my_Point ) ) || ( ( Low[shift] - up2[shift] ) > ( proximity_range * my_Point ) ) ) up2[shift] = 0;
         if ( ( ( up3[shift] - High[shift] ) > ( proximity_range * my_Point ) ) || ( ( Low[shift] - up3[shift] ) > ( proximity_range * my_Point ) ) ) up3[shift] = 0;
         if ( ( ( up4[shift] - High[shift] ) > ( proximity_range * my_Point ) ) || ( ( Low[shift] - up4[shift] ) > ( proximity_range * my_Point ) ) ) up4[shift] = 0;
         
         if ( ( ( down1[shift] - High[shift] ) > ( proximity_range * my_Point ) ) || ( ( Low[shift] - down1[shift] ) > ( proximity_range * my_Point ) ) ) down1[shift] = 0;
         if ( ( ( down2[shift] - High[shift] ) > ( proximity_range * my_Point ) ) || ( ( Low[shift] - down2[shift] ) > ( proximity_range * my_Point ) ) ) down2[shift] = 0;
         if ( ( ( down3[shift] - High[shift] ) > ( proximity_range * my_Point ) ) || ( ( Low[shift] - down3[shift] ) > ( proximity_range * my_Point ) ) ) down3[shift] = 0;
         if ( ( ( down4[shift] - High[shift] ) > ( proximity_range * my_Point ) ) || ( ( Low[shift] - down4[shift] ) > ( proximity_range * my_Point ) ) ) down4[shift] = 0;
      }

   }
    
   return;
}

